// exdump - 0.2 - By PolarRoot [pi9@hotmail.com]
//	dumptcp.c - TCP Dump Routines

#include "main.h"

// process_tcp_packet() Function
void process_tcp_packet (struct TCP_HEADER packet, int size) {
	char flags[8];
	char type[16];
	struct protoent prot;
	struct servent ss;
	struct servent sd;
	struct TCPFLAGS_STRUCT tcpflags;

	if (ignore_tcp_packet(packet)) return;

	convert_tcp_flags(packet.tcp, tcpflags);
	tcp_flags(tcpflags, flags);
	tcp_packet_type(tcpflags, type);
	prot=*getprotobynumber(packet.ip.ip_p);
	ss.s_name="";
	sd.s_name="";
	if (ntohs(packet.tcp.th_sport)<=1024) ss=*getservbyport(packet.tcp.th_sport, prot.p_name);
	if (ntohs(packet.tcp.th_dport)<=1024)   sd=*getservbyport(packet.tcp.th_dport, prot.p_name);

	if (OPT_VERBOSE_MODE!=1) {
		fprintf(hOUTPUT_FILE, "TCP:  From: %s (%5d)   To: %s (%5d)   Size: %d  [%s]\n", 
			inet_ntoa(packet.ip.ip_src), ntohs(packet.tcp.th_sport), 
			inet_ntoa(packet.ip.ip_dst), ntohs(packet.tcp.th_dport), 
			size, type);
		fflush(hOUTPUT_FILE);
	}
	else {
		fprintf(hOUTPUT_FILE, "TCP Packet Received [Size: %i]\n", size);
		fprintf(hOUTPUT_FILE, "IP Header:\n");
		fprintf(hOUTPUT_FILE, "\tHeader Length: %d\n", packet.ip.ip_hl);
		fprintf(hOUTPUT_FILE, "\tVersion: %d\n", packet.ip.ip_v);
		fprintf(hOUTPUT_FILE, "\tType of Service: %d\n", packet.ip.ip_tos);
		fprintf(hOUTPUT_FILE, "\tTotal Length: %d\n", packet.ip.ip_len);
		fprintf(hOUTPUT_FILE, "\tIdentification: %d\n", packet.ip.ip_id);
		fprintf(hOUTPUT_FILE, "\tFragment Offset Field: %d\n", packet.ip.ip_off);
		fprintf(hOUTPUT_FILE, "\tTime to Live: %d\n", packet.ip.ip_ttl);
		fprintf(hOUTPUT_FILE, "\tProtocol: %d (%s)\n", packet.ip.ip_p, prot.p_name);
		fprintf(hOUTPUT_FILE, "\tChecksum: %d\n", packet.ip.ip_sum);
		fprintf(hOUTPUT_FILE, "\tSource Address: %s\n", inet_ntoa(packet.ip.ip_src));
		fprintf(hOUTPUT_FILE, "\tDestination Address: %s\n", inet_ntoa(packet.ip.ip_dst));
		fprintf(hOUTPUT_FILE, "\n");
		fprintf(hOUTPUT_FILE, "TCP Header:\n");
		fprintf(hOUTPUT_FILE, "\tSource Port: %d (%s)\n", ntohs(packet.tcp.th_sport), ss.s_name);
		fprintf(hOUTPUT_FILE, "\tDestination Port: %d (%s)\n", ntohs(packet.tcp.th_dport), sd.s_name);
		fprintf(hOUTPUT_FILE, "\tSequence Number: %d\n", packet.tcp.th_seq);
		fprintf(hOUTPUT_FILE, "\tAcknowledgement Number: %d\n", packet.tcp.th_ack);
		fprintf(hOUTPUT_FILE, "\tTCP Flags: %s\n", flags);
		fprintf(hOUTPUT_FILE, "\tWindow: %d\n", packet.tcp.th_win);
		fprintf(hOUTPUT_FILE, "\tChecksum: %d\n", packet.tcp.th_sum);
		fprintf(hOUTPUT_FILE, "\tUrgent: %d\n", packet.tcp.th_urp);
		if (OPT_NO_DATA==0) {
			fprintf(hOUTPUT_FILE, "\nData:\n");
			fprintf(hOUTPUT_FILE, packet.space);
			fprintf(hOUTPUT_FILE, "\n");
		}
		fprintf(hOUTPUT_FILE, "\n\n");
		fflush(hOUTPUT_FILE);
	}
}

// convert_tcp_flags() Function
void convert_tcp_flags (struct tcphdr tcp, struct TCPFLAGS_STRUCT tcpflags) {
	if (tcp.th_flags & TH_FIN == TH_FIN)   tcpflags.fin=1;
	if (tcp.th_flags & TH_SYN == TH_SYN)   tcpflags.syn=1;
	if (tcp.th_flags & TH_RST == TH_RST)   tcpflags.rst=1;
	if (tcp.th_flags & TH_PUSH == TH_PUSH) tcpflags.psh=1;
	if (tcp.th_flags & TH_ACK == TH_ACK)   tcpflags.ack=1;
	if (tcp.th_flags & TH_URG == TH_URG)   tcpflags.urg=1;
	return;
}

// tcp_packet_type() Function
void tcp_packet_type (struct TCPFLAGS_STRUCT tcp, char type[16]) {
	// ACK is Least Important, so It Can Be Overwritten
	if (tcp.ack) strcpy(type, "    ACK");
	// All the Rest of the TCP Flags...
	if (tcp.fin) strcpy(type, "  CLOSE");
	if (tcp.syn) strcpy(type, "CONNECT");
	if (tcp.rst) strcpy(type, "  RESET");
	if (tcp.psh) strcpy(type, "   PUSH");
	if (tcp.urg) strcpy(type, " URGENT");
}

// tcp_flags() Function
void tcp_flags (struct TCPFLAGS_STRUCT tcp, char flags[8]) {
	int i;
	for (i=0; i<=8; i++)
		flags[i]='\0';
	if (tcp.fin) strcat(flags, "F");
	if (tcp.syn) strcat(flags, "S");
	if (tcp.rst) strcat(flags, "R");
	if (tcp.psh) strcat(flags, "P");
	if (tcp.ack) strcat(flags, "A");
	if (tcp.urg) strcat(flags, "U");
}

// ignore_tcp_packet() Function
int ignore_tcp_packet (struct TCP_HEADER packet) {
	if (OPT_WATCH_ALL==1) return 0;
// DEBUG
//	if (OPT_WATCH_LOCAL==1 & inet_ntoa(packet.ip.ip_dst)=="127.0.0.1" | inet_ntoa(packet.ip.ip_dst)=="localhost" | inet_ntoa(packet.ip.ip_dst)==LOCALHOST_NAME | inet_ntoa(packet.ip.ip_dst)==inet_ntoa(*(long *)(host->h_addr))) return 0;
//	if (OPT_WATCH_OUTSIDE==1 & inet_ntoa(packet.ip.ip_dst)!="127.0.0.1") return 0;
	if (OPT_WATCH_PORT==1 & ntohs(packet.tcp.th_dport)==port) return 0;
	return 1;
}

