// exdump - 0.2 - By PolarRoot [pi9@hotmail.com]
//	dumpudp.c - UDP Dump Routines

#include "main.h"

// process_udp_packet() Function
void process_udp_packet (struct UDP_HEADER packet, int size) {
	struct protoent prot;
	struct servent ss;
	struct servent sd;

	if (ignore_udp_packet(packet)) return;

	prot=*getprotobynumber(packet.ip.ip_p);
	ss.s_name="";
	sd.s_name="";
//	printf("ORIGINAL:  SOURCE: %d\tDEST: %d\n", packet.udp.uh_sport, packet.udp.uh_dport);
//	if (ntohs(packet.udp.uh_sport)<=1024) ss=*getservbyport(packet.udp.uh_sport, prot.p_name);
//	if (ntohs(packet.udp.uh_dport)<=1024)   sd=*getservbyport(packet.udp.uh_dport, prot.p_name);

	if (OPT_VERBOSE_MODE!=1) {
		fprintf(hOUTPUT_FILE, "UDP:  From: %s (%5d)   To: %s (%5d)   Size: %d\n", 
			inet_ntoa(packet.ip.ip_src), ntohs(packet.udp.uh_sport), 
			inet_ntoa(packet.ip.ip_dst), ntohs(packet.udp.uh_dport), 
			size);
		fflush(hOUTPUT_FILE);
	}
	else {
		fprintf(hOUTPUT_FILE, "UDP Packet Received [Size: %i]\n", size);
		fprintf(hOUTPUT_FILE, "IP Header:\n");
		fprintf(hOUTPUT_FILE, "\tHeader Length: %d\n", packet.ip.ip_hl);
		fprintf(hOUTPUT_FILE, "\tVersion: %d\n", packet.ip.ip_v);
		fprintf(hOUTPUT_FILE, "\tType of Service: %d\n", packet.ip.ip_tos);
		fprintf(hOUTPUT_FILE, "\tTotal Length: %d\n", packet.ip.ip_len);
		fprintf(hOUTPUT_FILE, "\tIdentification: %d\n", packet.ip.ip_id);
		fprintf(hOUTPUT_FILE, "\tFragment Offset Field: %d\n", packet.ip.ip_off);
		fprintf(hOUTPUT_FILE, "\tTime to Live: %d\n", packet.ip.ip_ttl);
		fprintf(hOUTPUT_FILE, "\tProtocol: %d (%s)\n", packet.ip.ip_p, prot.p_name);
		fprintf(hOUTPUT_FILE, "\tChecksum: %d\n", packet.ip.ip_sum);
		fprintf(hOUTPUT_FILE, "\tSource Address: %s\n", inet_ntoa(packet.ip.ip_src));
		fprintf(hOUTPUT_FILE, "\tDestination Address: %s\n", inet_ntoa(packet.ip.ip_dst));
		fprintf(hOUTPUT_FILE, "\n");
		fprintf(hOUTPUT_FILE, "UDP Header:\n");
		fprintf(hOUTPUT_FILE, "\tSource Port: %d (%s)\n", ntohs(packet.udp.uh_sport), ss.s_name);
		fprintf(hOUTPUT_FILE, "\tDestination Port: %d (%s)\n", ntohs(packet.udp.uh_dport), sd.s_name);
		fprintf(hOUTPUT_FILE, "\tLength: %d\n", packet.udp.uh_ulen);
		fprintf(hOUTPUT_FILE, "\tChecksum: %d\n", packet.udp.uh_sum);
		if (OPT_NO_DATA==0) {
			fprintf(hOUTPUT_FILE, "\nData:\n");
			fprintf(hOUTPUT_FILE, packet.space);
			fprintf(hOUTPUT_FILE, "\n");
		}
		fprintf(hOUTPUT_FILE, "\n\n");
		fflush(hOUTPUT_FILE);
	}
}

// ignore_udp_packet() Function
int ignore_udp_packet (struct UDP_HEADER packet) {
	if (OPT_WATCH_ALL==1) return 0;
// DEBUG
//	if (OPT_WATCH_LOCAL==1 & inet_ntoa(packet.ip.ip_dst)=="127.0.0.1" | inet_ntoa(packet.ip.ip_dst)=="localhost" | inet_ntoa(packet.ip.ip_dst)==LOCALHOST_NAME | inet_ntoa(packet.ip.ip_dst)==inet_ntoa(*(long *)(host->h_addr))) return 0;
//	if (OPT_WATCH_OUTSIDE==1 & inet_ntoa(packet.ip.ip_dst)!="127.0.0.1") return 0;
	if (OPT_WATCH_PORT==1 & ntohs(packet.udp.uh_dport)==port) return 0;
	return 1;
}

