// exdump - 0.2 - By PolarRoot [pi9@hotmail.com]
//	main.c - Main Program File
//	Thanks to:	Solar Designer - i ripped some of your code!

#include "main.h"

// Global Definitions
int rawtcp;
int rawudp;
int rawicmp;
struct hostent *host;
char LOCALHOST_NAME [256];

// Option Definitions
int OPT_WATCH_ALL=0;
int OPT_NO_DATA=0;
int OPT_WATCH_LOCAL=0;
int OPT_WATCH_OUTSIDE=0;
int OPT_WATCH_PORT=0;
int OPT_VERBOSE_MODE=0;
int OPT_OUTPUT_FILE=0;
char OUTPUT_FILE[1024]="";
FILE *hOUTPUT_FILE;
unsigned int port;
int OPT_WATCH_ICMP=1;
int OPT_WATCH_TCP=1;
int OPT_WATCH_UDP=1;

// setnonblocking() Function
void setnonblocking (int sock) {
	// This function ripped from Vic Metcalfe's 
	// Non Blocking Server Demo.
	int opts;
	opts=fcntl(sock, F_GETFL);
	if (opts<0) {
		perror("fcntl(F_GETFL)");
		exit(EXIT_FAILURE);
	}
	opts=(opts | O_NONBLOCK);
	if (fcntl(sock,F_SETFL,opts)<0) {
		perror("fcntl(F_SETFL)");
		exit(EXIT_FAILURE);
	}
	return;
}

// process_command() Function
int process_command (int argc, char **argv) {
	int c;

	while (0==0) {
		c=getopt(argc, argv, "c:df:hop:v?");
		if (c==EOF) break;
		switch (c) {
			case 'a':
				OPT_WATCH_ALL=1;
				break;
			case 'c':
				OPT_WATCH_ICMP=0;
				OPT_WATCH_TCP=0;
				OPT_WATCH_UDP=0;
				if (index(optarg, 'c')!=NULL) OPT_WATCH_ICMP=1;
				if (index(optarg, 't')!=NULL) OPT_WATCH_TCP=1;
				if (index(optarg, 'u')!=NULL) OPT_WATCH_UDP=1;
				if (OPT_WATCH_ICMP==0 & OPT_WATCH_TCP==0 & OPT_WATCH_UDP==0) return 1;
				break;
			case 'd':
				OPT_NO_DATA=1;
				break;
			case 'f':
				OPT_OUTPUT_FILE=1;
				strcpy(OUTPUT_FILE, optarg);
				break;
			case 'h' | '?':
				return 1;
				break;
			case 'l':
				OPT_WATCH_LOCAL=1;
				break;
			case 'o':
				OPT_WATCH_OUTSIDE=1;
				break;
			case 'p':
				OPT_WATCH_PORT=1;
				port=atoi(optarg);
				break;
			case 'v':
				OPT_VERBOSE_MODE=1;
				break;
			default:
				return 1;
				break;
		}
	}
	return 0;
}

// watch_mnemonic() Function
void watch_mnemonic (char watch[16]) {
	if (OPT_WATCH_ALL==1)     { strcpy(watch,"All Packets"); return; }
	if (OPT_WATCH_LOCAL==1)   { strcpy(watch,"Local Packets"); return; }
	if (OPT_WATCH_OUTSIDE==1) { strcpy(watch,"Outside Packets"); return; }
	if (OPT_WATCH_PORT==1)    { strcpy(watch,"Packets on Port"); return; }
	return;
}

// signal_handler() Function
void signal_handler (int signum) {
	if (signum==SIGHUP) {
		printf("\n\nexdump:  SIGNAL CAUGHT:  SIGHUP\n");
		if (hOUTPUT_FILE!=stdout) fprintf(hOUTPUT_FILE, "\n\nexdump:  SIGNAL CAUGHT:  SIGHUP\n");
	}
	if (signum==SIGINT) {
		printf("\n\nexdump:  SIGNAL CAUGHT:  SIGINT\n");
		if (hOUTPUT_FILE!=stdout) fprintf(hOUTPUT_FILE, "\n\nexdump:  SIGNAL CAUGHT:  SIGINT\n");
	}
	if (signum==SIGQUIT) {
		printf("\n\nexdump:  SIGNAL CAUGHT:  SIGQUIT\n");
		if (hOUTPUT_FILE!=stdout) fprintf(hOUTPUT_FILE, "\n\nexdump:  SIGNAL CAUGHT:  SIGQUIT\n");
	}
	if (signum==SIGTERM) {
		printf("\n\nexdump:  SIGNAL CAUGHT:  SIGTERM\n");
		if (hOUTPUT_FILE!=stdout) fprintf(hOUTPUT_FILE, "\n\nexdump:  SIGNAL CAUGHT:  SIGTERM\n");
	}
	printf("exdump:  Exitting Cleanly...\n");
	if (hOUTPUT_FILE!=stdout) fprintf(hOUTPUT_FILE, "exdump:  Exitting Cleanly...\n");
	close (rawtcp);
	close (rawudp);
	close (rawicmp);
	fclose (hOUTPUT_FILE);
	fflush (stdout);
	exit (0);
}

// main() Function
void main (int argc, char **argv) {
	int ret;
	struct TCP_HEADER tcppacket;
	struct UDP_HEADER udppacket;
	struct ICMP_HEADER icmppacket;
	int size;
	char watch[16];

	// Setup signal Handler
	if (signal (SIGHUP, signal_handler)==SIG_IGN)
		signal (SIGHUP, SIG_IGN);
	if (signal (SIGINT, signal_handler)==SIG_IGN)
		signal (SIGINT, SIG_IGN);
	if (signal (SIGQUIT, signal_handler)==SIG_IGN)
		signal (SIGQUIT, SIG_IGN);
	if (signal (SIGTERM, signal_handler)==SIG_IGN)
		signal (SIGTERM, SIG_IGN);
	// Set Priority Level
	ret=setpriority(PRIO_PROCESS, 0, 20);
	// Continue Loading...
	printf("exdump - v0.2 - By PolarRoot [pi9@hotmail.com] [http://exscan.netpedia.net]\n\n");
	if (process_command(argc, argv)) {
		printf("Usage:\t%s <options>\n\n", argv[0]);
		printf("Options:\n");
//		printf("\t-a           - show all packets (default)\n");
		printf("\t-c <proto>   - watch <proto> protocols (see below)\n");
		printf("\t-d           - do not show data in packet\n");
		printf("\t-f <file>    - send output to <file> file\n");
		printf("\t-h or -?     - show on-screen help (this screen)\n");
//		printf("\t-l           - show only packets for this computer\n");
//		printf("\t-o           - show only packets for other computers\n");
		printf("\t-p <port>    - show only packets for <port> port\n");
		printf("\t-v           - verbose mode (show internals of every packet)\n");
		printf("\n");
		printf("Excepted Values for Protocol:\n");
		printf("\tc            - watch ICMP packets\n");
		printf("\tt            - watch TCP packets\n");
		printf("\tu            - watch UDP packets\n");
		printf("\n");
		printf("Examples:\n");
		printf("\t%s -ctu -f tcpudp.dump -v\n", argv[0]);
		printf("\tDumps TCP and UDP packets to file `tcpudp.dump' with verbose mode.\n", argv[0]);
		printf("\n");
		exit (0);
	}

	// Open OUTPUT_FILE
	if (OPT_OUTPUT_FILE==1) {
		printf("Output Will Be Directed To The File: %s\n", OUTPUT_FILE);
		hOUTPUT_FILE=fopen(OUTPUT_FILE, "a");
		fprintf(hOUTPUT_FILE, "exdump - v0.2 - By PolarRoot [pi9@hotmail.com] [http://exscan.netpedia.net]\n\n");
		fprintf(hOUTPUT_FILE, "Output Will Be Directed To The File: %s\n", OUTPUT_FILE);
	}
	else {
		hOUTPUT_FILE=stdout;
	}

	ret = gethostname(LOCALHOST_NAME, sizeof(LOCALHOST_NAME));
	host = gethostbyname(LOCALHOST_NAME);
	fprintf(hOUTPUT_FILE, "Watching On: %s [%s]\n", LOCALHOST_NAME, inet_ntoa(*(long *)(host->h_addr)));

	if (OPT_WATCH_LOCAL==0 & OPT_WATCH_OUTSIDE==0 & OPT_WATCH_PORT==0)
		OPT_WATCH_ALL=1;
//	watch_mnemonic(watch);
//	fprintf(hOUTPUT_FILE, "Watching: %s\n", watch);
	if (OPT_WATCH_ICMP==1) fprintf(hOUTPUT_FILE, "Watching: ICMP packets\n");
	if (OPT_WATCH_TCP==1) fprintf(hOUTPUT_FILE, "Watching: TCP packets\n");
	if (OPT_WATCH_UDP==1) fprintf(hOUTPUT_FILE, "Watching: UDP packets\n");
	if (OPT_WATCH_PORT==1) fprintf(hOUTPUT_FILE, "Port: %d\n", port);
	if (OPT_VERBOSE_MODE==1) fprintf(hOUTPUT_FILE, "Verbose Mode Enabled\n");
	if (OPT_NO_DATA==1) fprintf(hOUTPUT_FILE, "Data Will Not Be Displayed\n");

	fprintf(hOUTPUT_FILE, "\n\n");

	rawicmp=socket(AF_INET, SOCK_RAW, IPPROTO_ICMP);
	rawtcp=socket(AF_INET, SOCK_RAW, IPPROTO_TCP);
	rawudp=socket(AF_INET, SOCK_RAW, IPPROTO_UDP);
	if (rawtcp<1 | rawudp<1 | rawicmp<1) {
		perror("exdump: RAW SOCKETS");
		exit (0);
	}
	
	setnonblocking (rawtcp);
	setnonblocking (rawudp);
	setnonblocking (rawicmp);

	printf("Watching...\n");
	while (0==0) {
		if (OPT_WATCH_ICMP==1) {
			size=read(rawicmp, &icmppacket, sizeof(icmppacket));
//			printf("ICMP Read: Size: %d\n", size);
			if (size>=sizeof(icmppacket.ip) & size!=-1)
				process_icmp_packet(icmppacket, size);
		}
		if (OPT_WATCH_TCP==1) {
			size=read(rawtcp, &tcppacket, sizeof(tcppacket));
//			printf("TCP Read:  Size: %d\n", size);
			if (size>=sizeof(tcppacket.ip) & size!=-1)
				process_tcp_packet(tcppacket, size);
		}
		if (OPT_WATCH_UDP==1) {
			size=read(rawudp, &udppacket, sizeof(udppacket));
//			printf("UDP Read:  Size: %d\n", size);
			if (size>=sizeof(udppacket.ip) & size!=-1)
				process_udp_packet(udppacket, size);
		}
	}

	close (rawtcp);
	close (rawudp);
	close (rawicmp);
	fclose (hOUTPUT_FILE);
	exit (0);
}

