// exdump - 0.2 - By PolarRoot [pi9@hotmail.com]
//	main.h - Main Header File

// BSD System Compatibility
#define _BSD_SOURCE

// Include Statements
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/resource.h>
#include <netdb.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/times.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>

// Structure Definitions
struct TCP_HEADER {
	struct ip ip;
	struct tcphdr tcp;
	char space[60-sizeof(struct ip)];
};
struct UDP_HEADER {
	struct ip ip;
	struct udphdr udp;
	char space[60-sizeof(struct ip)];
};
struct ICMP_HEADER {
	struct ip ip;
	struct icmphdr icmp;
	char space[60-sizeof(struct ip)];
};
struct TCPFLAGS_STRUCT {
// TCP-FLAGS section from <netinet/tcp.h>
    u_int16_t res1:4;
    u_int16_t doff:4;
    u_int16_t fin:1;
    u_int16_t syn:1;
    u_int16_t rst:1;
    u_int16_t psh:1;
    u_int16_t ack:1;
    u_int16_t urg:1;
    u_int16_t res2:2;
};

// Function Declarations
// in main.c
extern void setnonblocking (int sock);
extern int process_command (int argc, char **argv);
extern void watch_mnemonic (char watch[16]);
extern void signal_handler (int signum);
extern void main (int argc, char **argv);
// in dumptcp.c
extern void process_tcp_packet (struct TCP_HEADER packet, int size);
extern void convert_tcp_flags (struct tcphdr tcp, struct TCPFLAGS_STRUCT tcpflags);
extern void tcp_packet_type (struct TCPFLAGS_STRUCT tcp, char type[16]);
extern void tcp_flags (struct TCPFLAGS_STRUCT tcp, char flags[8]);
extern int ignore_tcp_packet (struct TCP_HEADER packet);
// in dumpudp.c
extern void process_udp_packet (struct UDP_HEADER packet, int size);
extern int ignore_udp_packet (struct UDP_HEADER packet);
// in dumpicmp.c
extern void process_icmp_packet (struct ICMP_HEADER packet, int size);
extern void icmp_type (struct ICMP_HEADER packet, char type[24]);
extern void icmp_code (struct ICMP_HEADER packet, char code[16]);
extern int ignore_icmp_packet (struct ICMP_HEADER packet);

// Global Definitions
extern int tcpraw;
extern int udpraw;
extern int icmpraw;
extern struct hostent *host;
extern char LOCALHOST_NAME [256];

// Option Definitions
extern int OPT_WATCH_ALL;
extern int OPT_NO_DATA;
extern int OPT_WATCH_LOCAL;
extern int OPT_WATCH_OUTSIDE;
extern int OPT_WATCH_PORT;
extern int OPT_VERBOSE_MODE;
extern int OPT_OUTPUT_FILE;
extern char OUTPUT_FILE[1024];
extern FILE *hOUTPUT_FILE;
extern unsigned int port;
extern int OPT_WATCH_ICMP;
extern int OPT_WATCH_TCP;
extern int OPT_WATCH_UDP;

